const express = require("express");
const router = express.Router();

const controller = require("../controller/productController");
const authorization = require("../middleware/Authorization");

//End-Point /api/product

// router.get("/", controller.getAllProducts);
router.get("/homePreview", controller.getBasicProductsData);
router.get("/category/:name", controller.getCategoryProducts);
router.get("/search/:name", controller.searchProducts);
router.get("/slugs", controller.productsSlug);
router.get("/slugs/:slug", controller.getProductBySlug);

//End-Points need Authorization
router.post("/", controller.addProduct);
router.put("/:slug", controller.updateProduct);
router.delete("/:slug", controller.deleteProduct);

module.exports = router;
